# Backend

## Deploy with Docker
> Prerequisite: Docker and Docker Compose have to be installed on your system </br>
> The Docker installation instructions for most operation systems can be found here: [https://docs.docker.com/get-docker/](https://docs.docker.com/get-docker/) </br>
> The Docker Compose installation instructions for most operation systems can be found here: [https://docs.docker.com/compose/install/](https://docs.docker.com/compose/install/)
> To use the prebuild images log into the private registry: docker login -u testuser -p LpH2v1mShPpC8Xeimkd2AISA03zaC+vq scrumdev.azurecr.io

### Quick Deployment with Docker Compose
1. Clone the git repo
2. Open the cloned repo's folder in a shell of your choice (as long as it supports Docker)
3. Tell Docker Compose to run the app alongside a database with `docker-compose up`

Other useful commands:
* Run attached (in the background): `docker-compose up -d`
* Stop: `docker-compose down`
* Restart: `docker-compose restart`

### Build the Container yourself (and run it)
1. Clone the git repo
2. Open the cloned repo's folder in a shell of your choice (as long as it supports Docker)
3. Tell Docker to build the app under the name "taskboard" with `docker build -t taskboard/backend .`
4. Tell Docker to run the app on port 5001 with `docker run -p 5001:80 taskboard/backend`

Other useful commands:
* Run detached: `docker run -d -p 5001:80 taskboard/backend`
* Run under specified name: `docker run -p 5001:80 --name backend taskboard/backend`